package org.dromara.payment.merchant.service;

import org.dromara.common.core.domain.R;
import org.dromara.payment.api.merchant.domain.RemoteBusMerchantAccountVo;
import org.dromara.payment.merchant.domain.BusMerchantAccount;
import org.dromara.payment.merchant.domain.vo.BusMerchantAccountVo;
import org.dromara.payment.merchant.domain.bo.BusMerchantAccountBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.payment.merchant.domain.vo.BusMerchantRechargeVo;
import org.dromara.payment.sys.domain.vo.SysSydAccountVo;

import java.util.Collection;
import java.util.List;

/**
 * 商户资金账户Service接口
 *
 * @author LionLi
 * @date 2024-04-03
 */
public interface IBusMerchantAccountService {

    /**
     * 查询商户资金账户
     */
    BusMerchantAccountVo queryById(Long id);

    /**
     * 查询商户资金账户列表
     */
    TableDataInfo<BusMerchantAccountVo> queryPageList(BusMerchantAccountBo bo, PageQuery pageQuery);

    /**
     * 查询商户资金账户列表
     */
    List<BusMerchantAccountVo> queryList(BusMerchantAccountBo bo);

    /**
     * 新增商户资金账户
     */
    Boolean insertByBo(BusMerchantAccountBo bo);

    /**
     * 修改商户资金账户
     */
    Boolean updateByBo(BusMerchantAccountBo bo);

    /**
     * 校验并批量删除商户资金账户信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 获取商户的资金账户
     * @param merId 商户id
     * @param sydId 服务商id
     * @return
     */
    List<BusMerchantAccountVo> getAccByMerIdAndSydId(Long merId, Long sydId);

    /**
     * 获取商户默认的资金账户
     * @param merId 商户id
     * @param sydId 服务商id
     * @return
     */

    BusMerchantAccountVo getDefaultAccByMerIdAndSydId(Long merId,Long sydId);

    /**
     * 递增或递减账户余额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateBalance(Long sydId,long unitId,long amount,String bankType);

    /**
     * 递增或递减冻结金额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateFrozen(Long sydId,long unitId,long amount,String bankType);


    /**
     * 递增或递减账户余额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateBalanceByAccId(int accId,long amount);

    /**
     * 递增或递减冻结金额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateFrozenByAccId(int accId,long amount);

    /**
     * 查询商户资金账户的充值信息
     * @param id 资金账户id
     * @return
     */
    public BusMerchantRechargeVo getRechargeAccount(int id);

    /**
     * 查询服务商提现账户信息
     * @param id 资金账户id
     * @return
     */
    public BusMerchantAccountVo getCashoutAccount(Long id);


    /***
     * 获取企业结算账户列表
     * @param bo
     * @param pageQuery
     * @return
     */
    public List<BusMerchantAccountVo> getMerAccountList(BusMerchantAccountBo bo, PageQuery pageQuery);



    /***
     * 创建企业虚拟户
     * @param sydId
     * @param merId
     * @param merName
     * @param bankType
     * @return
     */
    Boolean createXnAccount(Long sydId, Long merId, String merName, String bankType);


    public Boolean createThirdXnAccount(Long sydId, Long merId, String merName, String bankType,String bankCard,String accName);

}
